/*
 * ChangeMediator.java  $Revision: 1.4 $  $Date: 2007/10/03 04:39:39 $
 *
 * Copyright (C) 2007 Meldcraft Corporation
 *
 * This file is part of Scaffold.
 * 
 * Scaffold is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scaffold is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Scaffold.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.meldcraft.application.guis.mvc;

import java.awt.Component;
import java.lang.reflect.InvocationTargetException;

import com.meldcraft.application.ApplicationContext;
import com.meldcraft.application.ApplicationContextEvent;
import com.meldcraft.application.ApplicationContextListener;
import com.meldcraft.util.ReflectUtil;

/**
 * @version $Revision: 1.4 $ $Date: 2007/10/03 04:39:39 $
 * @author Rob Richards
 */
public class ChangeMediator extends ChangeEmitter implements ApplicationContextListener
{
    private Component   mTarget;

    public ChangeMediator(ApplicationContext context, String elementId, String contextKey, Component comp)
    {
        super(context, elementId, contextKey, comp);
        mTarget = comp;
        context.addApplicationContextListener(this, contextKey + ".change");
    }

    protected void handleApplicationContextChanged(ApplicationContextEvent e)
    {
        try
        {
            Object curVal = ReflectUtil.invokeMethod(mTarget, "getValue");
            Object newVal = getReceiveValue(e.getApplicationContext(), e.getValue());
            if (curVal != newVal)
            {
                if ((curVal == null) ||
                    (newVal == null) ||
                    !curVal.equals(newVal))
                {
                    ReflectUtil.invokeMethod(mTarget, "setValue", newVal);
                }
            }
        }
        catch (NoSuchMethodException e1)
        {
        }
        catch (IllegalAccessException e1)
        {
        }
        catch (InvocationTargetException e1)
        {
        } 
    }
}



